Index: src/edu/ucsb/nceas/metacat/DBEntityResolver.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBEntityResolver.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/DBEntityResolver.java	(revision 4080)
@@ -31,6 +31,9 @@
 import org.xml.sax.*;
 import org.xml.sax.helpers.DefaultHandler;
 
+import edu.ucsb.nceas.metacat.util.SystemUtil;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
+
 import java.sql.*;
 import java.io.File;
 import java.io.Reader;
@@ -208,12 +211,19 @@
       boolean tableHasRows = rs.next();
       if (tableHasRows) {
         systemid = rs.getString(1);
+        // system id may not have server url on front.  Add it if not.
+        if (!systemid.startsWith("http://")) {
+        	systemid = SystemUtil.getServerURL() + systemid;
+        }
       }
       stmt.close();
     } catch (SQLException e) {
       throw new SAXException
       ("DBEntityResolver.getDTDSystemID(): " + e.getMessage());
-    }
+    } catch (PropertyNotFoundException pnfe) {
+        throw new SAXException
+        ("DBEntityResolver.getDTDSystemID(): " + pnfe.getMessage());
+      }
     finally
     {
       try
@@ -285,170 +295,177 @@
   }
 
   /**
-   * Upload new DTD text identified by @systemId to Metacat file system
-   */
-  private String uploadDTD ( String systemId )
-                 throws SAXException
-  {
-    MetaCatUtil util = new MetaCatUtil();
-    String dtdPath = util.getOption("dtdPath");
-    String dtdURL = util.getOption("dtdURL");
+	 * Upload new DTD text identified by
+	 * 
+	 * @systemId to Metacat file system
+	 */
+	private String uploadDTD(String systemId) throws SAXException {
+		String dtdPath = null;
+		String dtdURL = null;
+		try {
+			dtdPath = SystemUtil.getContextDir() + "/dtd/";
+			dtdURL = SystemUtil.getContextURL() + "/dtd/";
+		} catch (PropertyNotFoundException pnfe) {
+			throw new SAXException("DBEntityResolver.uploadDTD: " + pnfe.getMessage());
+		}
 
-    // get filename from systemId
-    String filename = systemId;
-    int slash = Math.max(filename.lastIndexOf('/'), filename.lastIndexOf('\\'));
-    if ( slash > -1 ) {
-      filename = filename.substring(slash + 1);
-    }
+		// get filename from systemId
+		String filename = systemId;
+		int slash = Math.max(filename.lastIndexOf('/'), filename.lastIndexOf('\\'));
+		if (slash > -1) {
+			filename = filename.substring(slash + 1);
+		}
 
-    // writing dtd text on Metacat file system as filename
-    try {
-      // create a buffering character-input stream
-      // that uses a default-sized input buffer
-      BufferedReader in = new BufferedReader(dtdtext);
+		// writing dtd text on Metacat file system as filename
+		try {
+			// create a buffering character-input stream
+			// that uses a default-sized input buffer
+			BufferedReader in = new BufferedReader(dtdtext);
 
-      // open file writer to write the input into it
-      //String dtdPath = "/opt/tomcat/webapps/bojilova/dtd/";
-      File f = new File(dtdPath, filename);
-     synchronized (f) {
-      try {
-        if ( f.exists() ) {
-          throw new IOException("File already exist: " + f.getCanonicalFile());
-        //if ( f.exists() && !f.canWrite() ) {
-        //  throw new IOException("Not writable: " + f.getCanonicalFile());
-        }
-      } catch (SecurityException se) {
-        // if a security manager exists,
-        // its checkRead method is called for f.exist()
-        // or checkWrite method is called for f.canWrite()
-        throw se;
-      }
-      // create a buffered character-output stream
-      // that uses a default-sized output buffer
-      FileWriter fw = new FileWriter(f);
-      BufferedWriter out = new BufferedWriter(fw);
+			// open file writer to write the input into it
+			// String dtdPath = "/opt/tomcat/webapps/bojilova/dtd/";
+			File f = new File(dtdPath, filename);
+			synchronized (f) {
+				try {
+					if (f.exists()) {
+						throw new IOException("File already exist: "
+								+ f.getCanonicalFile());
+						// if ( f.exists() && !f.canWrite() ) {
+						// throw new IOException("Not writable: " +
+						// f.getCanonicalFile());
+					}
+				} catch (SecurityException se) {
+					// if a security manager exists,
+					// its checkRead method is called for f.exist()
+					// or checkWrite method is called for f.canWrite()
+					throw se;
+				}
+				// create a buffered character-output stream
+				// that uses a default-sized output buffer
+				FileWriter fw = new FileWriter(f);
+				BufferedWriter out = new BufferedWriter(fw);
 
-      // read the input and write into the file writer
-      String inputLine;
-      while ( (inputLine = in.readLine()) != null ) {
-        out.write(inputLine, 0, inputLine.length());
-        out.newLine(); //instead of out.write('\r\n');
-      }
+				// read the input and write into the file writer
+				String inputLine;
+				while ((inputLine = in.readLine()) != null) {
+					out.write(inputLine, 0, inputLine.length());
+					out.newLine(); // instead of out.write('\r\n');
+				}
 
-      // the input and the output streams must be closed
-      in.close();
-      out.flush();
-      out.close();
-      fw.close();
-     } // end of synchronized
-    } catch (MalformedURLException e) {
-      throw new SAXException
-      ("DBEntityResolver.uploadDTD(): " + e.getMessage());
-    } catch (IOException e) {
-      throw new SAXException
-      ("DBEntityResolver.uploadDTD(): " + e.getMessage());
-    } catch (SecurityException e) {
-      throw new SAXException
-      ("DBEntityResolver.uploadDTD(): " + e.getMessage());
-    }
+				// the input and the output streams must be closed
+				in.close();
+				out.flush();
+				out.close();
+				fw.close();
+			} // end of synchronized
+		} catch (MalformedURLException e) {
+			throw new SAXException("DBEntityResolver.uploadDTD(): " + e.getMessage());
+		} catch (IOException e) {
+			throw new SAXException("DBEntityResolver.uploadDTD(): " + e.getMessage());
+		} catch (SecurityException e) {
+			throw new SAXException("DBEntityResolver.uploadDTD(): " + e.getMessage());
+		}
 
-    //String dtdURL = "http://dev.nceas.ucsb.edu/bojilova/dtd/";
-    return  dtdURL + filename;
-  }
+		// String dtdURL = "http://dev.nceas.ucsb.edu/bojilova/dtd/";
+		return dtdURL + filename;
+	}
 
 
   /**
-   * Upload new DTD located at outside URL to Metacat file system
-   */
-  private String uploadDTDFromURL(InputStream istream, String systemId)
-                 throws SAXException
-  {
-    MetaCatUtil util = new MetaCatUtil();
-    String dtdPath = util.getOption("dtdPath");
-    String dtdURL = util.getOption("dtdURL");
+	 * Upload new DTD located at outside URL to Metacat file system
+	 */
+	private String uploadDTDFromURL(InputStream istream, String systemId)
+			throws SAXException {
+		String dtdPath = null;
+		String dtdURL = null;
+		try {
+			dtdPath = SystemUtil.getContextDir() + "/dtd/";
+			dtdURL = SystemUtil.getContextURL() + "/dtd/";
+		} catch (PropertyNotFoundException pnfe) {
+			throw new SAXException("DBEntityResolver.uploadDTDFromURL: "
+					+ pnfe.getMessage());
+		}
 
-    // get filename from systemId
-    String filename = systemId;
-    int slash = Math.max(filename.lastIndexOf('/'), filename.lastIndexOf('\\'));
-    if ( slash > -1 ) {
-      filename = filename.substring(slash + 1);
-    }
+		// get filename from systemId
+		String filename = systemId;
+		int slash = Math.max(filename.lastIndexOf('/'), filename.lastIndexOf('\\'));
+		if (slash > -1) {
+			filename = filename.substring(slash + 1);
+		}
 
-    // writing dtd text on Metacat file system as filename
-    try {
-      // create a buffering character-input stream
-      // that uses a default-sized input buffer
-      BufferedInputStream in = new BufferedInputStream(istream);
+		// writing dtd text on Metacat file system as filename
+		try {
+			// create a buffering character-input stream
+			// that uses a default-sized input buffer
+			BufferedInputStream in = new BufferedInputStream(istream);
 
-      // open file writer to write the input into it
-      //String dtdPath = "/opt/tomcat/webapps/bojilova/dtd/";
-      File f = new File(dtdPath, filename);
-     synchronized (f) {
-      try {
-        if ( f.exists() ) {
-          throw new IOException("File already exist: " + f.getCanonicalFile());
-        //if ( f.exists() && !f.canWrite() ) {
-        //  throw new IOException("Not writable: " + f.getCanonicalFile());
-        }
-      } catch (SecurityException se) {
-        // if a security manager exists,
-        // its checkRead method is called for f.exist()
-        // or checkWrite method is called for f.canWrite()
-        throw se;
-      }
-      // create a buffered character-output stream
-      // that uses a default-sized output buffer
-      FileWriter fw = new FileWriter(f);
-      BufferedWriter out = new BufferedWriter(fw);
+			// open file writer to write the input into it
+			//String dtdPath = "/opt/tomcat/webapps/bojilova/dtd/";
+			File f = new File(dtdPath, filename);
+			synchronized (f) {
+				try {
+					if (f.exists()) {
+						throw new IOException("File already exist: "
+								+ f.getCanonicalFile());
+						//if ( f.exists() && !f.canWrite() ) {
+						//  throw new IOException("Not writable: " + f.getCanonicalFile());
+					}
+				} catch (SecurityException se) {
+					// if a security manager exists,
+					// its checkRead method is called for f.exist()
+					// or checkWrite method is called for f.canWrite()
+					throw se;
+				}
+				// create a buffered character-output stream
+				// that uses a default-sized output buffer
+				FileWriter fw = new FileWriter(f);
+				BufferedWriter out = new BufferedWriter(fw);
 
-      // read the input and write into the file writer
-      int inputByte;
-      while ( (inputByte = in.read()) != -1 ) {
-        out.write(inputByte);
-        //out.newLine(); //instead of out.write('\r\n');
-      }
+				// read the input and write into the file writer
+				int inputByte;
+				while ((inputByte = in.read()) != -1) {
+					out.write(inputByte);
+					//out.newLine(); //instead of out.write('\r\n');
+				}
 
-      // the input and the output streams must be closed
-      in.close();
-      out.flush();
-      out.close();
-      fw.close();
-     } // end of synchronized
-    } catch (MalformedURLException e) {
-      throw new SAXException
-      ("DBEntityResolver.uploadDTDFromURL(): " + e.getMessage());
-    } catch (IOException e) {
-      throw new SAXException
-      ("DBEntityResolver.uploadDTDFromURL(): " + e.getMessage());
-    } catch (SecurityException e) {
-      throw new SAXException
-      ("DBEntityResolver.uploadDTDFromURL(): " + e.getMessage());
-    }
+				// the input and the output streams must be closed
+				in.close();
+				out.flush();
+				out.close();
+				fw.close();
+			} // end of synchronized
+		} catch (MalformedURLException e) {
+			throw new SAXException("DBEntityResolver.uploadDTDFromURL(): "
+					+ e.getMessage());
+		} catch (IOException e) {
+			throw new SAXException("DBEntityResolver.uploadDTDFromURL(): "
+					+ e.getMessage());
+		} catch (SecurityException e) {
+			throw new SAXException("DBEntityResolver.uploadDTDFromURL(): "
+					+ e.getMessage());
+		}
 
-    //String dtdURL = "http://dev.nceas.ucsb.edu/bojilova/dtd/";
-    return  dtdURL + filename;
-  }
+		//String dtdURL = "http://dev.nceas.ucsb.edu/bojilova/dtd/";
+		return dtdURL + filename;
+	}
 
-  /**
-   * Check URL Connection for @systemId, and return an InputStream
-   * that can be used to read from the systemId URL.  The parser ends
-   * up using this via the InputSource to read the DTD.
-   *
-   * @param systemId a URI (in practice URL) to be checked and opened
-   */
-  public static InputStream checkURLConnection (String systemId)
-                      throws SAXException
-  {
-    try {
+	/**
+	 * Check URL Connection for @systemId, and return an InputStream
+	 * that can be used to read from the systemId URL.  The parser ends
+	 * up using this via the InputSource to read the DTD.
+	 *
+	 * @param systemId a URI (in practice URL) to be checked and opened
+	 */
+	public static InputStream checkURLConnection(String systemId) throws SAXException {
+		try {
+			return (new URL(systemId).openStream());
 
-      return (new URL(systemId).openStream());
-
-    } catch (MalformedURLException e) {
-      throw new SAXException
-      ("DBEntityResolver.checkURLConnection(): " + e.getMessage());
-    } catch (IOException e) {
-      throw new SAXException
-      ("DBEntityResolver.checkURLConnection(): " + e.getMessage());
-    }
-  }
+		} catch (MalformedURLException e) {
+			throw new SAXException("DBEntityResolver.checkURLConnection(): "
+					+ e.getMessage());
+		} catch (IOException e) {
+			throw new SAXException("DBEntityResolver.checkURLConnection(): "
+					+ e.getMessage());
+		}
+	}
 }
Index: src/edu/ucsb/nceas/metacat/admin/MetaCatAdmin.java
===================================================================
--- src/edu/ucsb/nceas/metacat/admin/MetaCatAdmin.java	(nonexistent)
+++ src/edu/ucsb/nceas/metacat/admin/MetaCatAdmin.java	(revision 4080)
@@ -0,0 +1,50 @@
+/**
+ *  '$RCSfile$'
+ *    Purpose: A Class that implements utility methods like:
+ *             1/ Reding all doctypes from db connection
+ *             2/ Reading DTD or Schema file from Metacat catalog system
+ *             3/ Reading Lore type Data Guide from db connection
+ *  Copyright: 2000 Regents of the University of California and the
+ *             National Center for Ecological Analysis and Synthesis
+ *    Authors: Jivka Bojilova
+ * 
+ *   '$Author$'
+ *     '$Date$'
+ * '$Revision$'
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+package edu.ucsb.nceas.metacat.admin;
+
+import java.util.Vector;
+
+import javax.servlet.http.HttpServletRequest;
+
+/**
+ * A suite of utility classes for querying DB
+ * 
+ */
+public abstract class MetaCatAdmin {
+	
+	/**
+	 * Require subclasses to implement a properties validator.
+	 * 
+	 * @return a vector holding error message for any fields that fail
+	 *         validation.
+	 */
+	protected abstract Vector<String> validateOptions(HttpServletRequest request);
+
+}

